/*****************************************************************
  TRANSACT SQL Functions for IDAutomation Barcode Fonts V.2014
   Copyright, 2000-2014 IDAutomation.com, Inc. All rights reserved.
  Redistribution and use of this code in source and/or binary
  forms, with or without modification, are permitted provided
  that: (1) all copies of the source code retain the above
  unmodified copyright notice and this entire unmodified
  section of text, (2) You or Your organization owns a valid
  Developer License to this product from IDAutomation.com
  and, (3) when any portion of this code is bundled in any
  form with an application, a valid notice must be provided
  within the user documentation, start-up screen or in the
  help-about section of the application that specifies
  IDAutomation.com as the provider of the Software bundled
  with the application.
'*****************************************************************/
 CREATE FUNCTION dbo.Code39
(
@dataToEncode VARCHAR(255)
)
RETURNS VARCHAR(255)
BEGIN

-- Define the final holding place of the output string
DECLARE @printableString VARCHAR(255)
IF (@dataToEncode IS NOT NULL)
BEGIN

-- Declarations
DECLARE @i INT
DECLARE @currentChar CHAR(1)

SELECT @i = 1
SET @printableString = ''



WHILE @i <= LEN(@dataToEncode)
BEGIN
--Get each character one at a time
SELECT @currentChar = SUBSTRING(@dataToEncode, @i, 1)

/*To print the barcode symbol representing a space it is necessary
to type or print the = character instead of a space character*/
If @currentChar = ' ' 
SELECT @currentChar = '='

SELECT @printableString = @printableString + @currentChar
SELECT @i = @i + 1
END

SELECT @printableString = CONCAT('!',@printableString, '!')

END
--Return @printableString encoded data
RETURN @printableString

END

--Example of how to call function
/*GO
SELECT dbo.Code39('123456789012') AS EncoddData
  */

